close all; clc; clear all;

%%%%%%%%%%%%%%%%% CONFIGURATION ZONE %%%%%%%%%%%%%%%%%
% Select period
addpath(genpath('tools/'));
addpath(genpath('data/us0_cr/'));
addpath(genpath('data/us1_sr/'));
addpath(genpath('data/us2/'));
addpath(genpath('data/us3/'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

filename = 'all';

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

myperiods={
{'Sample: 1955-2017'},
{'Sample: 2007-2017'},
{'Sample: 1985-2007'},
{'Sample: 1955-1985'}
};

nbmodels = 1:12;

% Extracting estimation results

for kp=1:4
for km=nbmodels
	load(sprintf([myfilenames{kp} '%01.0f_oo.mat'], km));
	MarginalDensityLA(km,kp)=(eval(['oo' myfilenames{kp} num2str(km) '_.MarginalDensity.LaplaceApproximation']));
	MarginalDensityMHM(km,kp)=(eval(['oo' myfilenames{kp} num2str(km) '_.MarginalDensity.ModifiedHarmonicMean']));
end
end

% Plotting marginal densities
hFig1 = figure(1); clf; cla; 

for myperiod=1:4
	mygraph(myperiod) = subplot(2,2,myperiod); bar(((MarginalDensityLA(:,myperiod)))-(mean(MarginalDensityLA(:,myperiod))),'b'); axis tight; grid on;
	title(myperiods{myperiod},'FontSize',10); mygraph(myperiod).YLim = [1.1*min(min(MarginalDensityLA(:,myperiod)-mean(MarginalDensityLA(:,myperiod)))),1.1*max(max(MarginalDensityLA(:,myperiod)-mean(MarginalDensityLA(:,myperiod))))];

MarginalDensity(myperiod,nbmodels)=MarginalDensityLA(nbmodels,myperiod);
xlswrite('marginal_densities',MarginalDensity);
SWP0(MarginalDensity,['marginal_densities']);

end

	hold off;
	%set(gca,'FontSize',8);
f_name = strcat('fig_marginal_densities_',filename);
saveas(gcf,f_name,'epsc');