close all; clc; clear all;

filename = 'all';

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

myvariables={
'mc',
'zcap',
'rk',
'k',
'pk',
'c',
'inve',
'y',
'lab',
'pinf',
'w',
'r',
'g',
'kp',
'yf',
'output_gap',
'dy',
'pinfobs',
'robs',
'drate',
'utils',
'utilf',
'welfs',
'welff',
'welfd',
'wf',
'wage_gap'
};

myshocks={
'ea',
'eb',
'eg',
'eqs',
'em',
'epinf',
'ew'
};

myperiods={
{'Sample:','1955-2017'},
{'Sample:','2007-2017'},
{'Sample:','1985-2007'},
{'Sample:','1955-1985'}
};

nbmodels=1:12;

% Extracting estimation results
nbfilenames = 1:length(myfilenames);

for kf = nbfilenames
	load(['irfs_' myfilenames{kf} '.mat']);

for km=nbmodels
for kv=1:length(myvariables)
for ks=1:length(myshocks)
	ROIIRFs (kv,ks,km,kf) = RIRFs (kv,ks,km,1);
end
end
										   
										   
end

end


for kf = nbfilenames
for km=nbmodels
for ks=1:length(myshocks)
ROIIRFs (length(myvariables)+1,ks,km,kf) = RIRFs (24,ks,km,1)-RIRFs (23,ks,km,1);
end
end
										
																				  
										
																				   
										
end

fig_index = 1;

%Price markup shock

hFig1 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,6,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,6,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,6,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,6,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,6,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,6,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,6,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,6,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,6,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,6,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,6,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,6,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,6,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,6,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,6,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,6,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,6,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,6,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,6,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,6,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,6,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,6,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,6,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,6,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,6,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,6,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,6,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,6,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,6,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,6,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);

f_name = strcat('fig_oi_irfs_price_markup_',filename);
saveas(gcf,f_name,'epsc');

%Monetary policy shock

hFig2 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,5,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,5,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,5,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,5,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,5,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,5,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,5,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,5,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,5,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,5,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,5,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,5,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,5,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,5,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,5,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,5,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,5,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,5,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,5,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,5,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,5,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,5,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,5,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,5,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,5,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,5,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,5,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,5,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,5,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,5,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_monetary_policy_',filename);
saveas(gcf,f_name,'epsc');

%Wage markup shock

hFig3 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,7,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,7,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,7,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,7,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,7,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,7,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,7,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,7,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,7,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,7,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,7,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,7,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,7,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,7,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,7,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,7,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,7,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,7,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,7,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,7,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,7,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,7,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,7,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,7,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,7,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,7,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,7,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,7,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,7,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,7,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_wage_markup_',filename);
saveas(gcf,f_name,'epsc');

%Technology shock

hFig4 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,1,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,1,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,1,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,1,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,1,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,1,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,1,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,1,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,1,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,1,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,1,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,1,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,1,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,1,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,1,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,1,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,1,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,1,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,1,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,1,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,1,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,1,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,1,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,1,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,1,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,1,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,1,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,1,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,1,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,1,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_technology_',filename);
saveas(gcf,f_name,'epsc');

%Risk premium shock

hFig5 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,2,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,2,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,2,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,2,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,2,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,2,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,2,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,2,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,2,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,2,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,2,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,2,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,2,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,2,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,2,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,2,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,2,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,2,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,2,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,2,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,2,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,2,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,2,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,2,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,2,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,2,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,2,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,2,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,2,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,2,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_risk_premium_',filename);
saveas(gcf,f_name,'epsc');

%Investment specific shock

hFig6 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,4,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,4,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,4,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,4,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,4,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,4,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,4,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,4,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,4,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,4,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,4,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,4,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,4,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,4,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,4,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,4,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,4,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,4,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,4,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,4,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,4,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,4,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,4,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,4,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,4,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,4,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,4,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,4,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,4,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,4,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_investment_',filename);
saveas(gcf,f_name,'epsc');
saveas(gcf,f_name,'epsc');

%Government spending shock

hFig7 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1; mg=1;
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,3,nbmodels,1))],'group','b'); title({'1955-2017'},'FontSize',10);
	grid on; axis tight; ylabel({'Inflation'},'FontSize',10);

	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,3,nbmodels,2))],'group','b'); title({'2007-2017'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,3,nbmodels,3))],'group','b'); title({'1985-2007'},'FontSize',10);
	grid on; axis tight;
	
	mygraph1(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(10,3,nbmodels,4))],'group','b'); title({'1955-1985'},'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph1(:)],'xy'); mygraph1(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(10,3,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(10,3,nbmodels,:))])))*1.1]; mg=1;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,3,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Output'},'FontSize',10);

	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,3,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,3,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph2(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(8,3,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph2(:)],'xy'); mygraph2(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(8,3,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(8,3,nbmodels,:))])))*1.1]; mg=1;	

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,3,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Interest rate'},'FontSize',10);

	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,3,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,3,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph3(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(12,3,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph3(:)],'xy'); mygraph3(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(12,3,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(12,3,nbmodels,:))])))*1.1]; mg=1;

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,3,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Wage'},'FontSize',10);

	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,3,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,3,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph4(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(11,3,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph4(:)],'xy'); mygraph4(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(11,3,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(11,3,nbmodels,:))])))*1.1]; mg=1;

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,3,nbmodels,1))],'group','b');
	grid on; axis tight; ylabel({'Investment'},'FontSize',10);

	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,3,nbmodels,2))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,3,nbmodels,3))],'group','b');
	grid on; axis tight;
	
	mygraph5(mg) = subplot(i,ii,iii); iii=iii+1; mg=mg+1; bar([squeeze(ROIIRFs(7,3,nbmodels,4))],'group','b');
	grid on; axis tight;

	linkaxes([mygraph5(:)],'xy'); mygraph5(mg-1).YLim = [min(min(0,min([squeeze(ROIIRFs(7,3,nbmodels,:))])))*1.1,max(max(0,max([squeeze(ROIIRFs(7,3,nbmodels,:))])))*1.1]; mg=1;
	%set(gca,'FontSize',8);
f_name = strcat('fig_oi_irfs_government_',filename);
saveas(gcf,f_name,'epsc');