close all; clc; clear all;

%%%%%%%%%%%%%%%%% CONFIGURATION ZONE %%%%%%%%%%%%%%%%%
% Select period
addpath(genpath('tools/'));
addpath(genpath('data/us0_cr/'));
addpath(genpath('data/us1_sr/'));
addpath(genpath('data/us2/'));
addpath(genpath('data/us3/'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

filename = 'all';

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

myparamstodisplay={
'crr',
'crpi',
'cry',
'crdy',
'cngdp'
};

myperiods={
{'Sample:','1955-2017'},
{'Sample:','2007-2017'},
{'Sample:','1985-2007'},
{'Sample:','1955-1985'}
};

nbmodels=1:12;

% Extracting estimation results
nbparameters = 1:length(myparamstodisplay);
nbfilenames = 1:length(myfilenames);

for kf = nbfilenames
for kp = nbparameters
for km = nbmodels
	load(sprintf([myfilenames{kf} '%01.0f_oo.mat'], km));
	if(isfield(eval(['oo' myfilenames{kf} num2str(km) '_.posterior_mean.parameters']),myparamstodisplay{kp})==1)
	REstimationsMean (km,kp,kf) = real(eval(['oo' myfilenames{kf} num2str(km) '_.posterior_mean.parameters.' myparamstodisplay{kp}]));
	REstimationsStd (km,kp,kf) = real(eval(['oo' myfilenames{kf} num2str(km) '_.posterior_std.parameters.' myparamstodisplay{kp}]));
	REstimationsInf (km,kp,kf) = real(eval(['oo' myfilenames{kf} num2str(km) '_.posterior_hpdinf.parameters.' myparamstodisplay{kp}]));
	REstimationsSup (km,kp,kf) = real(eval(['oo' myfilenames{kf} num2str(km) '_.posterior_hpdsup.parameters.' myparamstodisplay{kp}]));
	end
end
end
end

fig_index = 1;

% Plotting parameters
hFig1 = figure(fig_index); clf; cla; fig_index=fig_index+1;
i=5;ii=4;iii=1;
	mygraph11 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,1,1))],'group','b'); set(gca,'FontSize',10); title('1955-2017','FontSize',10);
	grid on; axis tight; ylabel('$\rho$','Interpreter','LaTex','FontSize',10); %text(nbmodels,[squeeze(REstimationsMean(nbmodels,1,1))],num2str([squeeze(REstimationsMean(nbmodels,1,1))],'%0.2f'),'HorizontalAlignment','center','VerticalAlignment','top','FontSize',10)

	mygraph12 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,1,2))],'group','b'); set(gca,'FontSize',10); title('2007-2017','FontSize',10);
	grid on; axis tight;
	
	mygraph13 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,1,3))],'group','b'); set(gca,'FontSize',10); title('1985-2007','FontSize',10);
	grid on; axis tight;
	
	mygraph14 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,1,4))],'group','b'); set(gca,'FontSize',10); title('1955-1985','FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph11,mygraph12,mygraph13,mygraph14],'xy'); mygraph11.YLim = [0,max(max([squeeze(REstimationsMean(nbmodels,1,:))]))*1.1];
	

	mygraph21 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,2,1))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight; ylabel('$r_{\pi}$','Interpreter','LaTex','FontSize',10);
	
	mygraph22 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,2,2))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph23 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,2,3))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph24 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,2,4))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph21,mygraph22,mygraph23,mygraph24],'xy'); mygraph21.YLim = [0,max(max([squeeze(REstimationsMean(nbmodels,2,:))]))*1.1];

	mygraph31 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,3,1))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight; ylabel('$r_{y}$','Interpreter','LaTex','FontSize',10);
	
	mygraph32 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,3,2))],'group','b'); set(gca,'FontSize',10);
	grid on;axis tight;
	
	mygraph33 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,3,3))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph34 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,3,4))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	linkaxes([mygraph31,mygraph32,mygraph33,mygraph34],'xy'); mygraph31.YLim = [0,max(max([squeeze(REstimationsMean(nbmodels,3,:))]))*1.1];

	mygraph41 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,4,1))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight; ylabel('$r_{\triangle y}$','Interpreter','LaTex','FontSize',10);
	
	mygraph42 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,4,2))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph43 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,4,3))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph44 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,4,4))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	linkaxes([mygraph41,mygraph42,mygraph43,mygraph44],'xy'); mygraph41.YLim = [0,max(max([squeeze(REstimationsMean(nbmodels,4,:))]))*1.1];

	mygraph51 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,5,1))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight; ylabel('$r_{n}$','Interpreter','LaTex','FontSize',10);
	
	mygraph52 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,5,2))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph53 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,5,3))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;
	
	mygraph54 = subplot(i,ii,iii); iii=iii+1; bar([squeeze(REstimationsMean(nbmodels,5,4))],'group','b'); set(gca,'FontSize',10);
	grid on; axis tight;

	linkaxes([mygraph51,mygraph52,mygraph53,mygraph54],'xy'); mygraph51.YLim = [0,max(max([squeeze(REstimationsMean(nbmodels,5,:))]))*1.1];

	hold off;
	set(hFig1,'Position',[0 0 500 500]);
	hFig1.PaperUnits = 'inches';
	hFig1.PaperPosition = [0 0 11 9];
	set(gca,'FontSize',10);
	
f_name = strcat('fig_parameters_',filename);
saveas(gcf,f_name,'epsc');


hFig2 = figure(fig_index); clf; cla; fig_index=fig_index+1;
boxplot([squeeze(REstimationsMean(nbmodels,1,1)),squeeze(REstimationsSup(nbmodels,1,1)),squeeze(REstimationsInf(nbmodels,1,1)),squeeze(REstimationsStd(nbmodels,1,1))]');								
f_name = strcat('fig_parameters_bp_',filename);
saveas(gcf,f_name,'epsc');																														