clc; close all;clear all;clear all functions;rehash toolbox;

% Excel = actxGetRunningServer('Excel.Application');
% Excel.WorkBooks.Item('welfare_complete.xls').Save;
% Excel.WorkBooks.Item('welfare_complete.xls').Close;
% Excel.Quit;

fig_index = 1;

%%%%%%%%%%%%%%%%% CONFIGURATION ZONE %%%%%%%%%%%%%%%%%
% Select period
addpath(genpath('tools/'));

for myperiodtoselect = 1:4
close all;
if myperiodtoselect==1
addpath(genpath('data/us0_cr/'));
elseif myperiodtoselect==2
addpath(genpath('data/us1_sr/'));
elseif myperiodtoselect==3
addpath(genpath('data/us2/'));
elseif myperiodtoselect==4
addpath(genpath('data/us3/'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

filename=myfilenames{myperiodtoselect};

if myperiodtoselect==1
startDate = datenum(1955,01,01);
endDate = datenum(2017,01,01);
xData = linspace(startDate,endDate,248); % Length of filtered variables
[forecast_values,forecasters] = xlsread('usdata0.xlsx',1);
elseif myperiodtoselect==2
startDate = datenum(2007,04,01);
endDate = datenum(2017,01,01);
xData = linspace(startDate,endDate,40); % Length of filtered variables
[forecast_values,forecasters] = xlsread('usdata1.xlsx',1);
elseif myperiodtoselect==3
startDate = datenum(1985,04,01);
endDate = datenum(2007,01,01);
xData = linspace(startDate,endDate,88); % Length of filtered variables
[forecast_values,forecasters] = xlsread('usdata2.xlsx',1);
elseif myperiodtoselect==4
startDate = datenum(1955,01,01);
endDate = datenum(1984,12,01);
xData = linspace(startDate,endDate,120); % Length of filtered variables
[forecast_values,forecasters] = xlsread('usdata3.xlsx',1);
end

for i = 1:length(forecasters)
      % compose a command to assign each column to a variable with the same name as the header
      commandExec = [forecasters{i}, ' = ', 'forecast_values(:,', num2str(i) , ');'];
      % execute the composed command to actually create the variable
      evalin('base', commandExec );
end

myvariables={
'mc',
'zcap',
'rk',
'k',
'pk',
'c',
'inve',
'y',
'lab',
'pinf',
'w',
'r',
'g',
'kp',
'yf',
'output_gap',
'dy',
'pinfobs',
'robs',
'drate',
'utils',
'utilf',
'welfs',
'welff',
'welfd',
'wf',
'wage_gap'
};

myshocks={
'ea',
'eb',
'eg',
'eqs',
'em',
'epinf',
'ew'
};

myparams={
'csadjcost',
'csigma',
'chabb',
'cprobw',
'csigl',
'cprobp',
'cindw',
'cindp',
'czcap',
'cfc',
'crr',
'crpi',
'cry',
'crdy',
'cngdp',
'constepinf',
'constelab',
'ctrend',
'cgy',
'calfa',
'crhoa',
'crhob',
'crhog',
'crhoqs',
'crhoms',
'crhopinf',
'crhow',
'cmap',
'cmaw',

'ea',
'eb',
'eg',
'eqs',
'em',
'epinf',
'ew'
};

nbmodels = 1:12;
nbparameters=1:length(myparams);
nbshocks=1:7;
nbforecasts=1:12;
nbirfs=1:30;

incr_col=0;
suite1=1;

incr_line2=0;

% Extracting estimation results

for kp=nbparameters
incr_col=0;
incr_line1=0;
for km=nbmodels
	load(sprintf([filename '%01.0f_oo.mat'], km));
	if(isfield(eval(['oo' filename num2str(km) '_.posterior_mean.parameters']),myparams{kp})==1)
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_mean.parameters.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_std.parameters.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_hpdinf.parameters.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_hpdsup.parameters.' myparams{kp}])); suite1=suite1+1;
	elseif(isfield(eval(['oo' filename num2str(km) '_.posterior_mean.shocks_std']),myparams{kp})==1)
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_mean.shocks_std.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_std.shocks_std.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_hpdinf.shocks_std.' myparams{kp}])); suite1=suite1+1;
	REstimations (km-incr_line1+incr_line2,suite1+incr_col) = real(eval(['oo' filename num2str(km) '_.posterior_hpdsup.shocks_std.' myparams{kp}])); suite1=suite1+1;
	end
	incr_col=incr_col+4;
	incr_line1=incr_line1+1;
	suite1=1;
end
incr_line2=incr_line2+1;
end

f_name = strcat('estimations_',filename);
save(f_name,'REstimations');
xlswrite(f_name,REstimations);

SWP3(REstimations,['estimations_',filename]);


for km=nbmodels
for ks=nbshocks
for knbirfs=nbirfs
for kv=1:length(myvariables)
transmatrix1 = eval(['oo' filename num2str(km) '_.irfs.' myvariables{kv} '_' myshocks{ks}])/100;
transmatrix2 = eval(['oo' filename num2str(km) '_.PosteriorIRF.dsge.Mean.' myvariables{kv} '_' myshocks{ks}]);
RIRFs (kv,ks,km,knbirfs) = transmatrix1(knbirfs);
RPIRFs (kv,ks,km,knbirfs) = transmatrix2(knbirfs);
adjustedirfs1 = eval(['oo' filename num2str(km) '_.irfs.' myvariables{kv} '_' myshocks{ks}])/(eval(['oo' filename num2str(km) '_.var(kv,kv)'])*100);
RIRFs2 (kv,ks,km,knbirfs) = adjustedirfs1(knbirfs);
end
end
end
end

f_name = strcat('irfs_',filename);
save(f_name,'RIRFs');

% Extracting variable variances, log data densities and loss functions

for km=nbmodels
for kv=1:length(myvariables)
RVariances (kv,km) = eval(['oo' filename num2str(km) '_.var(kv,kv)']);
RVariancesPF (kv,km) = mean(eval(['oo' filename num2str(km) '_.PointForecast.Var.' myvariables{kv} '(:)']));
RVariancesMF (kv,km) = mean(eval(['oo' filename num2str(km) '_.MeanForecast.Var.' myvariables{kv} '(:)']));
RVariancesIRFs (kv,km) = var(RIRFs (kv,6,km,:));
RVariancesPIRFs (kv,km) = var(RPIRFs (kv,6,km,:));					  
end
end

f_name = strcat('variances_',filename);
save(f_name,'RVariances');
xlswrite(f_name,RVariances);


for km=nbmodels
for kv=1:length(myvariables)
RVariancesUpdated (kv,km) = var( eval(['oo' filename num2str(km) '_.UpdatedVariables.' myvariables{kv} '(:)']) );
RVariancesFiltered (kv,km) = var( eval(['oo' filename num2str(km) '_.FilteredVariables.' myvariables{kv} '(:)']) );
end
end

f_name = strcat('variances_updated_',filename);
save(f_name,'RVariancesUpdated');
xlswrite(f_name,RVariancesUpdated);

% Extracting filtered and updated variables

for km=nbmodels
for kv=1:length(myvariables)
for ks=1:length(eval(['oo' filename num2str(km) '_.UpdatedVariables.' myvariables{kv}]))
RUpdatedVariables (kv,ks,km) = eval(['oo' filename num2str(km) '_.UpdatedVariables.' myvariables{kv} '(ks)']);
RFilteredVariables (kv,ks,km) = eval(['oo' filename num2str(km) '_.FilteredVariables.' myvariables{kv} '(ks)']);
end
end
end

f_name = strcat('variablesu_',filename);
save(f_name,'RUpdatedVariables');

f_name = strcat('variablesf_',filename);
save(f_name,'RFilteredVariables');

% Computing loss functions

for km=nbmodels
XLOSS(km,1)=RVariances(10,km);		% Inflation
XLOSS(km,2)=RVariances(16,km)/100;	% Output gap
XLOSS(km,3)=RVariances(20,km);		% Interest rate differential
XLOSS(km,4)=RVariances(11,km)/100;	% Wages

XLOSS(km,6)=RVariancesPF(10,km);		% Inflation
XLOSS(km,7)=RVariancesPF(16,km)/100;	% Output gap
XLOSS(km,8)=RVariancesPF(20,km);		% Interest rate differential
XLOSS(km,9)=RVariancesPF(11,km)/100;	% Wages

XLOSS(km,11)=RVariancesMF(10,km);		% Inflation
XLOSS(km,12)=RVariancesMF(16,km)/100;	% Output gap
XLOSS(km,13)=RVariancesMF(20,km);		% Interest rate differential
XLOSS(km,14)=RVariancesMF(11,km)/100;	% Wages

XLOSS(km,16)=RVariancesIRFs(10,km);		% Inflation
XLOSS(km,17)=RVariancesIRFs(16,km)/100;	% Output gap
XLOSS(km,18)=RVariancesIRFs(20,km);		% Interest rate differential
XLOSS(km,19)=RVariancesIRFs(11,km)/100;	% Wages

XLOSS(km,21)=RVariancesPIRFs(10,km);		% Inflation
XLOSS(km,22)=RVariancesPIRFs(16,km)/100;	% Output gap
XLOSS(km,23)=RVariancesPIRFs(20,km);		% Interest rate differential
XLOSS(km,24)=RVariancesPIRFs(11,km)/100;	% Wages

XLOSS(km,26)=RVariancesUpdated(10,km);		% Inflation
XLOSS(km,27)=RVariancesUpdated(16,km)/100;	% Output gap
XLOSS(km,28)=RVariancesUpdated(20,km);		% Interest rate differential
XLOSS(km,29)=RVariancesUpdated(11,km)/100;	% Wages

XLOSS(km,31)=RVariancesFiltered(10,km);		% Inflation
XLOSS(km,32)=RVariancesFiltered(16,km)/100;	% Output gap
XLOSS(km,33)=RVariancesFiltered(20,km);		% Interest rate differential
XLOSS(km,34)=RVariancesFiltered(11,km)/100;	% Wages

for xl1=1:5
for xl2=1:5
for xl3=1:5
HeatFunc(km,xl1,xl2,xl3) = 100*(XLOSS(km,1)+((xl1-1)/4)*XLOSS(km,2)+((xl2-1)/4)*XLOSS(km,3)+((xl3-1)/4)*XLOSS(km,4));
HeatFuncPF(km,xl1,xl2,xl3) = 100*(XLOSS(km,6)+((xl1-1)/4)*XLOSS(km,7)+((xl2-1)/4)*XLOSS(km,8)+((xl3-1)/4)*XLOSS(km,9));
HeatFuncMF(km,xl1,xl2,xl3) = 100*(XLOSS(km,11)+((xl1-1)/4)*XLOSS(km,12)+((xl2-1)/4)*XLOSS(km,13)+((xl3-1)/4)*XLOSS(km,14));
HeatFuncIRFs(km,xl1,xl2,xl3) = 100*(XLOSS(km,16)+((xl1-1)/4)*XLOSS(km,17)+((xl2-1)/4)*XLOSS(km,18)+((xl3-1)/4)*XLOSS(km,19));
HeatFuncPIRFs(km,xl1,xl2,xl3) = 10000*(XLOSS(km,21)+((xl1-1)/4)*XLOSS(km,22)+((xl2-1)/4)*XLOSS(km,23)+((xl3-1)/4)*XLOSS(km,24));
HeatFuncFiltered(km,xl1,xl2,xl3) = 100*(XLOSS(km,26)+((xl1-1)/4)*XLOSS(km,27)+((xl2-1)/4)*XLOSS(km,28)+((xl3-1)/4)*XLOSS(km,29));
HeatFuncUpdated(km,xl1,xl2,xl3) = 100*(XLOSS(km,31)+((xl1-1)/4)*XLOSS(km,32)+((xl2-1)/4)*XLOSS(km,33)+((xl3-1)/4)*XLOSS(km,34));
end
end
end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
yvalues = {'0','0.25','0.5','0.75','1'};
h = heatmap(xvalues,yvalues,squeeze(HeatFunc(nbmodels,1:5,1,1))','Colormap',colormap(flipud(gray)));
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap weights';
f_name = strcat('fig_loss_functions_hm00_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
yvalues = {'0','0.25','0.5','0.75','1'};
h = heatmap(xvalues,yvalues,squeeze(HeatFunc(nbmodels,1:5,3,1))','Colormap',colormap(flipud(gray)));
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap weights';
f_name = strcat('fig_loss_functions_hm10_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
yvalues = {'0','0.25','0.5','0.75','1'};
h = heatmap(xvalues,yvalues,squeeze(HeatFunc(nbmodels,1:5,1,3))','Colormap',colormap(flipud(gray)));
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap weights';
f_name = strcat('fig_loss_functions_hm01_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
yvalues = {'0','0.25','0.5','0.75','1'};
h = heatmap(xvalues,yvalues,squeeze(HeatFunc(nbmodels,1:5,3,3))','Colormap',colormap(flipud(gray)));
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap weights';
f_name = strcat('fig_loss_functions_hm11_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFunc(nbmodels,1:2:5,1,1)])', squeeze([HeatFunc(nbmodels,1:2:5,3,1)])', squeeze([HeatFunc(nbmodels,1:2:5,5,1)])', squeeze([HeatFunc(nbmodels,1:2:5,1,3)])', squeeze([HeatFunc(nbmodels,1:2:5,3,3)])', squeeze([HeatFunc(nbmodels,1:2:5,5,3)])', squeeze([HeatFunc(nbmodels,1:2:5,1,5)])', squeeze([HeatFunc(nbmodels,1:2:5,3,5)])', squeeze([HeatFunc(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hm_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncPF(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncPF(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncPF(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncPF(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncPF(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncPF(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncPF(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncPF(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncPF(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmpf_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncMF(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncMF(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncMF(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncMF(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncMF(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncMF(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncMF(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncMF(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncMF(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmmf_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncIRFs(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncIRFs(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmirfs_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncPIRFs(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncPIRFs(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmpirfs_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncFiltered(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncFiltered(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmfiltered_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFuncUpdated(nbmodels,1:2:5,1,1)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,3,1)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,5,1)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,1,3)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,3,3)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,5,3)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,1,5)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,3,5)])', squeeze([HeatFuncUpdated(nbmodels,1:2:5,5,5)])');
h = heatmap(xvalues,yvalues,allmatrix0,'Colormap',colormap(flipud(gray)));colorbar('off');h.ColorScaling = 'scaledrows';
%h.Title = 'Spectrum of loss functions';
%%h.XLabel = 'Models';
%h.YLabel = 'Output gap, interest rate differential, and wage inflation weights';
h.CellLabelFormat = '%.1f';
h.GridVisible = 'off';
old_warning_state = warning('off', 'MATLAB:structOnObject');
hs = struct(h);
warning(old_warning_state);
hs.XAxis.TickValues = xvalues;
hs.XAxis.TickLabelInterpreter = 'none';
hs.YAxis.TickValues = yvalues;
hs.YAxis.TickLabelInterpreter = 'latex';
hs.YAxis.FontSize = 8;

f_name = strcat('fig_loss_functions_hmupdated_all_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set(groot,'defaulttextinterpreter','latex');  
set(groot,'defaultAxesTickLabelInterpreter','latex');  
set(groot,'defaultLegendInterpreter','latex'); 
hmfig = figure(fig_index); clf; cla; fig_index=fig_index+1;
xvalues = {'1','2','3','4','5','6','7','8','9','10','11','12'};
%yvalues = {'$\lambda_{y}$=0.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.25 $\lambda_{r}$=0.00','$\lambda_{y}$=0.50 $\lambda_{r}$=0.00','$\lambda_{y}$=0.75 $\lambda_{r}$=0.00','$\lambda_{y}$=1.00 $\lambda_{r}$=0.00','$\lambda_{y}$=0.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.25 $\lambda_{r}$=0.25','$\lambda_{y}$=0.50 $\lambda_{r}$=0.25','$\lambda_{y}$=0.75 $\lambda_{r}$=0.25','$\lambda_{y}$=1.00 $\lambda_{r}$=0.25','$\lambda_{y}$=0.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.25 $\lambda_{r}$=0.50','$\lambda_{y}$=0.50 $\lambda_{r}$=0.50','$\lambda_{y}$=0.75 $\lambda_{r}$=0.50','$\lambda_{y}$=1.00 $\lambda_{r}$=0.50','$\lambda_{y}$=0.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.25 $\lambda_{r}$=0.75','$\lambda_{y}$=0.50 $\lambda_{r}$=0.75','$\lambda_{y}$=0.75 $\lambda_{r}$=0.75','$\lambda_{y}$=1.00 $\lambda_{r}$=0.75','$\lambda_{y}$=0.00 $\lambda_{r}$=1.00','$\lambda_{y}$=0.25 $\lambda_{r}$=1.00','$\lambda_{y}$=0.50 $\lambda_{r}$=1.00','$\lambda_{y}$=0.75 $\lambda_{r}$=1.00','$\lambda_{y}$=1.00 $\lambda_{r}$=1.00'};
yvalues = {'$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=0.5','$\lambda_{y}$=0.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=0.5 $\lambda_{w}$=1.0','$\lambda_{y}$=0.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=0.5 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0','$\lambda_{y}$=1.0 $\lambda_{r}$=1.0 $\lambda_{w}$=1.0'};
allmatrix0 = vertcat(squeeze([HeatFunc(nbmodels,1:2:5,1,1)])', squeeze([HeatFunc(nbmodels,1:2:5,3,1)])', squeeze([HeatFunc(nbmodels,1:2:5,5,1)])', squeeze([HeatFunc(nbmodels,1:2:5,1,3)])', squeeze([HeatFunc(nbmodels,1:2:5,3,3)])', squeeze([HeatFunc(nbmodels,1:2:5,5,3)])', squeeze([HeatFunc(nbmodels,1:2:5,1,5)])', squeeze([HeatFunc(nbmodels,1:2:5,3,5)])', squeeze([HeatFunc(nbmodels,1:2:5,5,5)])');
h = contourf(allmatrix0,'LineStyle','none');
colormap(flipud(gray(256)));
contourcbar;
set(gca,'XTick',1:length(xvalues),'XTickLabel',xvalues);
set(gca,'YTick',1:length(yvalues),'YTickLabel',yvalues);
%set(get(gca, 'Title'), 'string', 'Spectrum of loss functions','Interpreter','none');
%set(get(gca, 'XLabel'), 'string', 'Models','Interpreter','none');
set(groot,'defaulttextinterpreter','none');  
set(groot,'defaultAxesTickLabelInterpreter','none');  
set(groot,'defaultLegendInterpreter','none'); 

f_name = strcat('fig_loss_functions_hm_allc_',filename);
print(f_name,'-depsc2','-r0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(fig_index); clf; cla; fig_index=fig_index+1;

	subplot(2,2,1); bar(XLOSS(:,1),'b'); axis tight; grid on;
	title('Inflation','FontSize',10);
	ylabel({'Loss'},'FontSize',10);

	subplot(2,2,2); bar(XLOSS(:,2),'b'); axis tight; grid on;
	title('Output gap','FontSize',10);

	subplot(2,2,3); bar(XLOSS(:,3),'b'); axis tight; grid on;
	title('Interest rate','FontSize',10);
	ylabel({'Loss'},'FontSize',10);

	subplot(2,2,4); bar(XLOSS(:,4),'b'); axis tight; grid on;
	title('Wage','FontSize',10);

	hold off;
	%set(gca,'FontSize',8);
f_name = strcat('fig_loss_',filename);
saveas(gcf,f_name,'epsc');


hFig2 = figure(fig_index); clf; cla; fig_index=fig_index+1; mg=1;

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.00$'},'Interpreter','Latex','FontSize',10);
	ylabel({'$\lambda_{y}$ = 0.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.50*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.50$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+1.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 1.00$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 0.50'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.50*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+1.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 1.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.50*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+1.00*XLOSS(:,3),'b'); axis tight; grid on; mg=mg+1;

	linkaxes([mygraph(:)],'xy');
	mygraph(1).YLim = [0,max(max(XLOSS(:,1)+max(XLOSS(:,2))+max(XLOSS(:,3))))*1.1];

	hold off;
	%set(gca,'FontSize',8);
f_name = strcat('fig_loss_functions_1_',filename);
saveas(gcf,f_name,'epsc');


hFig3 = figure(fig_index); clf; cla; fig_index=fig_index+1; mg=1;

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.00$'},'Interpreter','Latex','FontSize',10);
	ylabel({'$\lambda_{y}$ = 0.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.50*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.50$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+1.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 1.00$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 0.50'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.50*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+1.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 1.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.50*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+1.00*XLOSS(:,3)+0.50*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;

	linkaxes([mygraph(:)],'xy');
	mygraph(1).YLim = [0,max(max(XLOSS(:,1)+max(XLOSS(:,2))+max(XLOSS(:,3))+max(0.5*XLOSS(:,4))))*1.1];

	hold off;
	%set(gca,'FontSize',8);
f_name = strcat('fig_loss_functions_2_',filename);
saveas(gcf,f_name,'epsc');



hFig4 = figure(fig_index); clf; cla; fig_index=fig_index+1; mg=1;

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.00$'},'Interpreter','Latex','FontSize',10);
	ylabel({'$\lambda_{y}$ = 0.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+0.50*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 0.50$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.00*XLOSS(:,2)+1.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	title({'$\lambda_{r} = 1.00$'},'Interpreter','Latex','FontSize',10);
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 0.50'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+0.50*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+0.50*XLOSS(:,2)+1.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	ylabel({'$\lambda_{y}$ = 1.00'},'Interpreter','Latex','FontSize',10);

	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+0.50*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;
	
	mygraph(mg) = subplot(5,3,mg); bar(XLOSS(:,1)+1.00*XLOSS(:,2)+1.00*XLOSS(:,3)+1.00*XLOSS(:,4),'b'); axis tight; grid on; mg=mg+1;

	linkaxes([mygraph(:)],'xy');
	mygraph(1).YLim = [0,max(max(XLOSS(:,1)+max(XLOSS(:,2))+max(XLOSS(:,3))+max(XLOSS(:,4))))*1.1];

	hold off;
	%set(gca,'FontSize',8);
f_name = strcat('fig_loss_functions_3_',filename);
saveas(gcf,f_name,'epsc');

% Extracting variance decomposition (ST and LT)

for km=nbmodels
for kv=1:length(myvariables)
for ks=nbshocks
RVarDecomp (kv,ks,km) = 100*eval(['oo' filename num2str(km) '_.conditional_variance_decomposition(kv,1,ks)']);
RVarDecomp (kv,ks,km+10) = 100*eval(['oo' filename num2str(km) '_.gamma_y{7,1}(kv,ks)']);
end
end
end

f_name = strcat('vardecomp_',filename);
save(f_name,'RVarDecomp');

% Bar plotting variance decomposition (ST and LT)

hFig5 = figure(fig_index); clf; cla; fig_index=fig_index+1;

	subplot(7,4,1); bar(squeeze(RVarDecomp(10,6,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	title({'Inflation';'short run'},'FontSize',10);
	ylabel({'Price markup';'shock'},'FontSize',10);

	subplot(7,4,2); bar(squeeze(RVarDecomp(8,6,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	title({'Output';'short run'},'FontSize',10);

	subplot(7,4,3); bar(squeeze(RVarDecomp(10,6,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	title({'Inflation';'long run'},'FontSize',10);

	subplot(7,4,4); bar(squeeze(RVarDecomp(8,6,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	title({'Output';'long run'},'FontSize',10);

	subplot(7,4,5); bar(squeeze(RVarDecomp(10,5,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Monetary policy';'shock'},'FontSize',10);

	subplot(7,4,6); bar(squeeze(RVarDecomp(8,5,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,7); bar(squeeze(RVarDecomp(10,5,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,8); bar(squeeze(RVarDecomp(8,5,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,9); bar(squeeze(RVarDecomp(10,7,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Wage markup';'shock'},'FontSize',10);

	subplot(7,4,10); bar(squeeze(RVarDecomp(8,7,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,11); bar(squeeze(RVarDecomp(10,7,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,12); bar(squeeze(RVarDecomp(8,7,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,13); bar(squeeze(RVarDecomp(10,1,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Technology';'shock'},'FontSize',10);

	subplot(7,4,14); bar(squeeze(RVarDecomp(8,1,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,15); bar(squeeze(RVarDecomp(10,1,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	
	subplot(7,4,16); bar(squeeze(RVarDecomp(8,1,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,17); bar(squeeze(RVarDecomp(10,2,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Risk premium';'shock'},'FontSize',10);

	subplot(7,4,18); bar(squeeze(RVarDecomp(8,2,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,19); bar(squeeze(RVarDecomp(10,2,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	
	subplot(7,4,20); bar(squeeze(RVarDecomp(8,2,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,21); bar(squeeze(RVarDecomp(10,4,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Invest. specific';'shock'},'FontSize',10);

	subplot(7,4,22); bar(squeeze(RVarDecomp(8,4,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,23); bar(squeeze(RVarDecomp(10,4,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	
	subplot(7,4,24); bar(squeeze(RVarDecomp(8,4,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,25); bar(squeeze(RVarDecomp(10,3,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);
	ylabel({'Gov. spending';'shock'},'FontSize',10);

	subplot(7,4,26); bar(squeeze(RVarDecomp(8,3,nbmodels)),'b'); axis tight; grid on; ylim([0 100]);

	subplot(7,4,27); bar(squeeze(RVarDecomp(10,3,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);
	
	subplot(7,4,28); bar(squeeze(RVarDecomp(8,3,nbmodels+10)),'b'); axis tight; grid on; ylim([0 100]);

	hold off;
	set(hFig5,'Position',[0 0 600 1000]);
	%set(gca,'FontSize',8);
	hFig5.PaperUnits = 'inches';
	hFig5.PaperPosition = [0 0 9 13];
	f_name = strcat('fig_vardecomp_0_',filename);
	print(f_name,'-depsc2','-r0');

% Extracting impulse response functions



% Plotting impulse response functions

set(0, 'DefaultAxesColorOrder',[0 0 0;1 0 0;0 1 0;0 0 1], 'DefaultAxesLineStyleOrder','-|--|:|-.')

hFig6 = figure(fig_index); clf; cla; fig_index=fig_index+1;

	subplot(7,5,1); plot(squeeze(RIRFs(10,6,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	title('Inflation','FontSize',10);
	ylabel({'Price';'markup'},'FontSize',10);

	subplot(7,5,2); plot(squeeze(RIRFs(8,6,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	title('Output','FontSize',10);

	subplot(7,5,3); plot(squeeze(RIRFs(12,6,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	title('Nominal rate','FontSize',10);

	subplot(7,5,4); plot(squeeze(RIRFs(11,6,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	title('Wage','FontSize',10);

	subplot(7,5,5); plot(squeeze(RIRFs(7,6,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	title('Investment','FontSize',10);

	subplot(7,5,6); plot(squeeze(RIRFs(10,5,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Monetary';'policy'},'FontSize',10);

	subplot(7,5,7); plot(squeeze(RIRFs(8,5,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,8); plot(squeeze(RIRFs(12,5,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,9); plot(squeeze(RIRFs(11,5,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,10); plot(squeeze(RIRFs(7,5,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,11); plot(squeeze(RIRFs(10,7,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Wage';'markup'},'FontSize',10);

	subplot(7,5,12); plot(squeeze(RIRFs(8,7,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,13); plot(squeeze(RIRFs(12,7,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,14); plot(squeeze(RIRFs(11,7,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,15); plot(squeeze(RIRFs(7,7,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,16); plot(squeeze(RIRFs(10,1,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Technology'},'FontSize',10);

	subplot(7,5,17); plot(squeeze(RIRFs(8,1,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	
	subplot(7,5,18); plot(squeeze(RIRFs(12,1,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,19); plot(squeeze(RIRFs(11,1,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,20); plot(squeeze(RIRFs(7,1,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,21); plot(squeeze(RIRFs(10,2,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Risk';'premium'},'FontSize',10);

	subplot(7,5,22); plot(squeeze(RIRFs(8,2,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	
	subplot(7,5,23); b = plot(squeeze(RIRFs(12,2,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,24); plot(squeeze(RIRFs(11,2,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,25); plot(squeeze(RIRFs(7,2,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,26); plot(squeeze(RIRFs(10,4,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Investment';'specific'},'FontSize',10);

	subplot(7,5,27); plot(squeeze(RIRFs(8,4,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	
	subplot(7,5,28); plot(squeeze(RIRFs(12,4,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,29); plot(squeeze(RIRFs(11,4,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,30); plot(squeeze(RIRFs(7,4,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,31); plot(squeeze(RIRFs(10,3,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	ylabel({'Government';'spending'},'FontSize',10);

	subplot(7,5,32); plot(squeeze(RIRFs(8,3,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;
	
	subplot(7,5,33); plot(squeeze(RIRFs(12,3,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,34); plot(squeeze(RIRFs(11,3,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	subplot(7,5,35); plot(squeeze(RIRFs(7,3,nbmodels,:))'); set(gca,'FontSize',10); axis tight; grid on;

	hold off;
	%set(gca,'FontSize',8);
	set(hFig6,'Position',[0 0 800 1000]);

	hFig6.PaperUnits = 'inches';
	hFig6.PaperPosition = [0 0 11 13];
	lbl = {'1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','10 ','11 ','12 '};
	legendflex([b], lbl, 'ref', gcf,'anchor', {'s','n'},'buffer',[-5 40],'nrow',2,'fontsize',10,'box',['off']);
	f_name = strcat('fig_irfs_',filename);
	print(f_name,'-depsc2','-r0');

set(0,'defaultAxesLineStyleOrder','remove');
set(0,'defaultAxesColorOrder','remove');

hFig7 = figure(fig_index); clf; fig_index=fig_index+1;

ha = tight_subplot(4,3,[.0 .055],[.05 .01],[.05 .01]);

for km=nbmodels

cpie(km)			= 1+(eval(['oo' filename num2str(km) '_.posterior_mean.parameters.constepinf'])/100);
cgamma(km)			= 1+(eval(['oo' filename num2str(km) '_.posterior_mean.parameters.ctrend'])/100);
csigma(km)			= eval(['oo' filename num2str(km) '_.posterior_mean.parameters.csigma']);
constebeta(km)		= eval(['oo' filename num2str(km) '_.posterior_mean.parameters.constebeta']);
cbeta(km)			= 1/((constebeta(km)/100)+1);
cr(km)				= cpie(km)/(cbeta(km)*cgamma(km)^(-csigma(km)));
conster(km)			= (cr(km) - 1)*100;

	axes(ha(km)); b = plot(xData,RUpdatedVariables(12,1:length(xData),km)+conster(km),'-b',xData,robs(1:length(xData)),'--k','LineWidth',1);
	axis tight; grid on;
	h = legend(['Model ',num2str(km)],'History'); set(h,'Location','best','FontSize',10,'Box','off');
set(ha(1:9),'XTickLabel','','xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
set(ha(10:12),'xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
datetick('x','YYQQ','keepticks');
end
	
f_name = strcat('fig_variables_comparison_robs_',filename);
saveas(gcf,f_name,'epsc');


for km=nbmodels

for ktime=1:length(xData)
ARMSD_robs_temp (km,ktime) = (RUpdatedVariables(12,ktime,km)+conster(km)-robs(ktime))^2;
end

for ktime=2:length(xData)
ARMSFD_robs_temp (km,ktime) = (RFilteredVariables(12,ktime-1,km)+conster(km)-robs(ktime))^2;
end

ARMSD_robs(km) = sqrt(sum(ARMSD_robs_temp(km,:))/length(xData));
ARMSFD_robs(km) = sqrt(sum(ARMSFD_robs_temp(km,:))/(length(xData)-1));

end

ARMSD_robs_mean		= mean(robs(:));
ARMSD_robs_maxmin	= max(robs(:))-min(robs(:));

f_name = strcat('rmsd_robs_',filename);
save(f_name,'ARMSD_robs');
f_name = strcat('rmsfd_robs_',filename);
save(f_name,'ARMSFD_robs');
f_name = strcat('rmsd_robs_mean_',filename);
save(f_name,'ARMSD_robs_mean');
f_name = strcat('rmsd_robs_maxmin_',filename);
save(f_name,'ARMSD_robs_maxmin');


hFig8 = figure(fig_index); clf; fig_index=fig_index+1;

ha = tight_subplot(4,3,[.0 .055],[.05 .01],[.05 .01]);

for km=nbmodels

constepinf(km) = eval(['oo' filename num2str(km) '_.posterior_mean.parameters.constepinf']);

	axes(ha(km)); b = plot(xData,(RUpdatedVariables(10,1:length(xData),km))+constepinf(km),'-b',xData,pinfobs(1:length(xData)),'--k','LineWidth',1);
	axis tight; grid on;
	h = legend(['Model ',num2str(km)],'History'); set(h,'Location','best','FontSize',10,'Box','off');
set(ha(1:9),'XTickLabel','','xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
set(ha(10:12),'xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
datetick('x','YYQQ','keepticks');
end

f_name = strcat('fig_variables_comparison_pinfobs_',filename);
saveas(gcf,f_name,'epsc');


for km=nbmodels

for ktime=1:length(xData)
ARMSD_pinfobs_temp (km,ktime) = (RUpdatedVariables(10,ktime,km)+constepinf(km)-pinfobs(ktime))^2;
end

for ktime=2:length(xData)
ARMSFD_pinfobs_temp (km,ktime) = (RFilteredVariables(10,ktime-1,km)+constepinf(km)-pinfobs(ktime))^2;
end

ARMSD_pinfobs(km) = sqrt(sum(ARMSD_pinfobs_temp(km,:))/length(xData));
ARMSFD_pinfobs(km) = sqrt(sum(ARMSFD_pinfobs_temp(km,:))/(length(xData)-1));

end

ARMSD_pinfobs_mean		= mean(pinfobs(:));
ARMSD_pinfobs_maxmin	= max(pinfobs(:))-min(pinfobs(:));

f_name = strcat('rmsd_pinfobs_',filename);
save(f_name,'ARMSD_pinfobs');
f_name = strcat('rmsfd_pinfobs_',filename);
save(f_name,'ARMSFD_pinfobs');
f_name = strcat('rmsd_pinfobs_mean_',filename);
save(f_name,'ARMSD_pinfobs_mean');
f_name = strcat('rmsd_pinfobs_maxmin_',filename);
save(f_name,'ARMSD_pinfobs_maxmin');


hFig9 = figure(fig_index); clf; fig_index=fig_index+1;

ha = tight_subplot(4,3,[.0 .055],[.05 .01],[.05 .01]);

for km=nbmodels

ctrend(km) = eval(['oo' filename num2str(km) '_.posterior_mean.parameters.ctrend']);

	axes(ha(km)); b = plot(xData,(RUpdatedVariables(17,1:length(xData),km))+ctrend(km),'-b',xData,dy(1:length(xData)),'--k','LineWidth',1);
	axis tight; grid on;
	h = legend(['Model ',num2str(km)],'History'); set(h,'Location','best','FontSize',10,'Box','off');
set(ha(1:9),'XTickLabel','','xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
set(ha(10:12),'xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
datetick('x','YYQQ','keepticks');
end
	
f_name = strcat('fig_variables_comparison_dy_',filename);
saveas(gcf,f_name,'epsc');


for km=nbmodels

for ktime=1:length(xData)
ARMSD_dy_temp (km,ktime) = (RUpdatedVariables(17,ktime,km)+ctrend(km)-dy(ktime))^2;
end

for ktime=2:length(xData)
ARMSFD_dy_temp (km,ktime) = (RFilteredVariables(17,ktime-1,km)+ctrend(km)-dy(ktime))^2;
end

ARMSD_dy(km) = sqrt(sum(ARMSD_dy_temp(km,:))/length(xData));
ARMSFD_dy(km) = sqrt(sum(ARMSFD_dy_temp(km,:))/(length(xData)-1));

end

ARMSD_dy_mean	= mean(dy(:));
ARMSD_dy_maxmin	= max(dy(:))-min(dy(:));

f_name = strcat('rmsd_dy_',filename);
save(f_name,'ARMSD_dy');
f_name = strcat('rmsfd_dy_',filename);
save(f_name,'ARMSFD_dy');
f_name = strcat('rmsd_dy_mean_',filename);
save(f_name,'ARMSD_dy_mean');
f_name = strcat('rmsd_dy_maxmin_',filename);
save(f_name,'ARMSD_dy_maxmin');

for km=nbmodels
for kv=1:length(myshocks)
for ks=1:length(eval(['oo' filename num2str(km) '_.SmoothedShocks.' myshocks{kv}]))
RSmoothedShocks (kv,ks,km) = eval(['oo' filename num2str(km) '_.SmoothedShocks.' myshocks{kv} '(ks)']);
end
end
end

myshocksname={
'Technology',
'Risk premium',
'Government spending',
'Investment-specific',
'Monetary policy',
'Price markup',
'Wage markup'
};

set(0, 'DefaultAxesColorOrder',[0 0 0;1 0 0;0 1 0;0 0 1], 'DefaultAxesLineStyleOrder','-|--|:|-.')

hFig10 = figure(fig_index); clf; cla; fig_index=fig_index+1;

for kv=1:length(myshocks)
for km=nbmodels
	subplot(3,3,kv); b = plot(xData,RSmoothedShocks(kv,1:length(xData),km),'LineWidth',0.1);
	axis tight; grid on; hold on; title(myshocksname(kv),'FontSize',10);
	set(gca,'XTickLabel','','xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
	set(gca,'xlim',[startDate endDate],'XTick',linspace(startDate,endDate,5),'FontSize',8);
	datetick('x','YYQQ','keepticks');
end
end
	lbl = {'1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','10 ','11 ','12 '};
	legendflex(gca, lbl, 'ref', gcf,'anchor', [5 5],'buffer',[-80  50],'nrow',3,'fontsize',10,'box',['off']);
	
f_name = strcat('fig_shocks_',filename);
saveas(gcf,f_name,'epsc');

end

run('runrmsd.m');
run('runrmsfd.m');
run('runrmsfd_demeaned.m');
run('runrmsd_demeaned.m');
run('runrmsd_dy.m');
run('runrmsd_pinfobs.m');
run('runrmsd_robs.m');
run('runrules.m');
run('runwelfare.m');
run('runwelfare_xls.m');
run('runwelfare_xls1.m');
run('runparam_prices.m');
run('runparam_mp.m');
run('runoutput.m');
run('runoiirfs.m');
run('runmd.m');
run('runloss.m');