close all; clc; clear all;

%%%%%%%%%%%%%%%%% CONFIGURATION ZONE %%%%%%%%%%%%%%%%%
% Select period
addpath(genpath('tools/'));
addpath(genpath('data/us0_cr/'));
addpath(genpath('data/us1_sr/'));
addpath(genpath('data/us2/'));
addpath(genpath('data/us3/'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

filename = 'all';

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

myperiods={
{'1955-2017'},
{'2007-2017'},
{'1985-2007'},
{'1955-1985'}
};

nbmodels=1:12;
nbfilenames = 1:length(myfilenames);

hFig1 = figure(1); clf; cla; 

for kf=nbfilenames
	load(['rmsd_robs_' myfilenames{kf} '.mat']);
	load(['rmsd_robs_mean_' myfilenames{kf} '.mat']);
	load(['rmsd_robs_maxmin_' myfilenames{kf} '.mat']);

	mygraph(kf) = subplot(3,4,kf); bar(100*ARMSD_robs(:)/ARMSD_robs_maxmin(:),'b'); grid on; axis tight;
	if kf==1
	ylabel('$r_{t}$','Interpreter','LaTex','FontSize',10);
	end
	title(myperiods{kf},'FontSize',10);
	max_robs(kf)=max(100*ARMSD_robs(:)/ARMSD_robs_maxmin(:));
end
	linkaxes([mygraph(1:4)],'xy'); mygraph(1).YLim = [0,1.1*max(max_robs(:))];

for kf=(nbfilenames+4)

	load(['rmsd_pinfobs_' myfilenames{kf-4} '.mat']);
	load(['rmsd_pinfobs_mean_' myfilenames{kf-4} '.mat']);
	load(['rmsd_pinfobs_maxmin_' myfilenames{kf-4} '.mat']);

	mygraph(kf) = subplot(3,4,kf); bar(100*ARMSD_pinfobs(:)/ARMSD_pinfobs_maxmin(:),'b'); grid on; axis tight;
	if kf==5
	ylabel('$\pi_{t}$','Interpreter','LaTex','FontSize',10);
	end
	max_pinfobs(kf)=max(100*ARMSD_pinfobs(:)/ARMSD_pinfobs_maxmin(:));
end
	linkaxes([mygraph(5:8)],'xy'); mygraph(5).YLim = [0,1.1*max(max_pinfobs(:))];

for kf=(nbfilenames+8)
	load(['rmsd_dy_' myfilenames{kf-8} '.mat']);
	load(['rmsd_dy_mean_' myfilenames{kf-8} '.mat']);
	load(['rmsd_dy_maxmin_' myfilenames{kf-8} '.mat']);

	mygraph(kf) = subplot(3,4,kf); bar(100*ARMSD_dy(:)/ARMSD_dy_maxmin(:),'b'); grid on; axis tight;
	if kf==9
	ylabel('$\Delta y_{t}$','Interpreter','LaTex','FontSize',10);
	end
	max_dy(kf)=max(100*ARMSD_dy(:)/ARMSD_dy_maxmin(:));
end
	linkaxes([mygraph(9:12)],'xy'); mygraph(9).YLim = [0,1.1*max(max_dy(:))];

	%set(gca,'FontSize',8);

f_name = strcat('fig_rmsd_',filename);
saveas(gcf,f_name,'epsc');
