close all; clc; clear all;

%%%%%%%%%%%%%%%%% CONFIGURATION ZONE %%%%%%%%%%%%%%%%%
% Select period
addpath(genpath('tools/'));
addpath(genpath('data/us0_cr/'));
addpath(genpath('data/us1_sr/'));
addpath(genpath('data/us2/'));
addpath(genpath('data/us3/'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

filename = 'all';

myfilenames={
'us0',
'us1',
'us2',
'us3'
};

myperiods={
{'Sample: 1955-2017'},
{'Sample: 2007-2017'},
{'Sample: 1985-2007'},
{'Sample: 1955-1985'}
};

nbmodels=1:12;
nbfilenames = 1:length(myfilenames);

hFig1 = figure(1); clf; cla; 

for kf=nbfilenames

	load(['rmsd_robs_' myfilenames{kf} '.mat']);
	load(['rmsd_robs_mean_' myfilenames{kf} '.mat']);
	load(['rmsd_robs_maxmin_' myfilenames{kf} '.mat']);

	mygraph(kf) = subplot(2,2,kf); bar(ARMSD_robs(:)/ARMSD_robs_maxmin(:),'b'); axis tight;
	mymax(kf) = max(ARMSD_robs(:)/ARMSD_robs_maxmin(:))*1.1;
	title(myperiods{kf},'FontSize',10);

end
	linkaxes([mygraph(:)],'xy'); mygraph(1).YLim = [0,max(mymax(:))];

	%set(gca,'FontSize',8);

f_name = strcat('fig_rmsd_robs_',filename);
saveas(gcf,f_name,'epsc');
